diff --git a/eos/private/pc_eos.f90 b/eos/private/pc_eos.f90
index 73031183..f9641a13 100644
--- a/eos/private/pc_eos.f90
+++ b/eos/private/pc_eos.f90
@@ -1366,31 +1044,35 @@
          EA=exp(-ALPHA*eta)
          EB=exp(-BETA*eta)
          EG=exp(-GAMMA*eta)
-         F=log(1.d0-EA)+log(1.d0-EB)+log(1.d0-EG)-UP/DN ! F_{thermal}/NT
+         F=log(1.d0-EA)+log(1.d0-EB)+log(1.-EG)-UP/DN ! F_{thermal}/NT
 
-         !UP1=A1+2d0*A2*eta+3.*A3*eta**2+4.*A4*eta**3+6d0*A6*eta**5+8.*A8*eta**7
-         UP1=A1+eta*(2d0*A2+eta*(3.d0*A3+eta*(4.d0*A4+eta*eta*(6d0*A6+eta*eta*8d0*A8))))
+         !UP1=A1+2.*A2*eta+3.*A3*eta**2+4.*A4*eta**3+6.*A6*eta**5+8.*A8*eta**7
+         UP1=A1+eta*(2.*A2+eta*(3.*A3+eta*(4.*A4+eta*eta*(6.*A6+eta*eta*8.*A8))))
 
-         !UP2=2d0*A2+6d0A3*eta+12d0*A4*eta**2+30.*A6*eta**4+56d0A8*eta**6
-         UP2=2d0*A2+eta*(6d0*A3+eta*(12d0*A4+eta*eta*(30d0*A6+eta*eta*56d0*A8)))
+         !UP2=2.*A2+6.*A3*eta+12.*A4*eta**2+30.*A6*eta**4+56.*A8*eta**6
+         UP2=2.*A2+eta*(6.*A3+eta*(12.*A4+eta*eta*(30.*A6+eta*eta*56.*A8)))
 
-         !DN1=2d0*B2*eta+4.*B4*eta**3+5.*B5*eta**4+6d0*B6*eta**5+7.*B7*eta**6+9.*B9*eta**8+11d0*B11*eta**10.
-         DN1=eta*(2d0*B2+eta*eta*(4d0*B4+eta*(5d0*B5+eta*(6d0*B6+eta*(7d0*B7+eta*eta*(9d0*B9+eta*eta*11d0*B11))))))
+         !DN1=2.*B2*eta+4.*B4*eta**3+5.*B5*eta**4+6.*B6*eta**5+7.*B7*eta**6+9.*B9*eta**8+11.*B11*eta**10.
+         DN1=eta*(2.*B2+eta*eta*(4.*B4+eta*(5.*B5+eta*(6.*B6+eta*(7.*B7+eta*eta*(9.*B9+eta*eta*11.*B11))))))
 
-         !DN2=2d0*B2+12d0*B4*eta**2+20.*B5*eta**3+30.*B6*eta**4+42d0*B7*eta**5+72d0*B9*eta**7+110.*B11*eta**9
-         DN2=2d0*B2+eta*eta*(12d0*B4+eta*(20d0*B5+eta*(30d0*B6+eta*(42d0*B7+eta*eta*(72d0*B9+eta*eta*110d0*B11)))))
+         !DN2=2.*B2+12.*B4*eta**2+20.*B5*eta**3+30.*B6*eta**4+42.*B7*eta**5+72.*B9*eta**7+110.*B11*eta**9
+         DN2=2.*B2+eta*eta*(12.*B4+eta*(20.*B5+eta*(30.*B6+eta*(42.*B7+eta*eta*(72.*B9+eta*eta*110.*B11)))))
 
          U=ALPHA*EA/(1.d0-EA)+BETA*EB/(1.d0-EB)+GAMMA*EG/(1.d0-EG) &
             - (UP1*DN-DN1*UP)/(DN*DN) ! int.en./NT/eta
          CV=ALPHA*ALPHA*EA/((1.d0-EA)*(1.d0-EA))+BETA*BETA*EB/((1.d0-EB)*(1.d0-EB)) &
             + GAMMA*GAMMA*EG/((1.d0-EG)*(1.d0-EG)) &
-            + ((UP2*DN-DN2*UP)*DN-2d0*(UP1*DN-DN1*UP)*DN1)/(DN*DN*DN) ! cV/eta^2
+            + ((UP2*DN-DN2*UP)*DN-2.*(UP1*DN-DN1*UP)*DN1)/(DN*DN*DN) ! cV/eta^2
          U=U*eta
          CV=CV*eta*eta
       end if
       S=U-F
+! Add zero-point lattice energy:
+      E0=1.5d0*U1*eta
+      U=U+E0
+      F=F+E0
       return
-      end subroutine HLfit12
+      end subroutine HLfit8
 
       subroutine CORMIX(RS,GAME,Zmean,Z2mean,Z52,Z53,Z321, &
         FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX)
@@ -1408,65 +1090,60 @@
 !               = \Delta p +  d \Delta p / d ln T
 !         PDRMIX=(1/n_{ion}kT)d\Delta P / d ln n_e
 ! (composition is assumed fixed: Zmean,Z2mean,Z52,Z53=constant)
-      type(auto_diff_real_2var_order1), intent(in) :: RS,GAME
-      real(dp), intent(in) :: Zmean,Z2mean,Z52,Z53,Z321
-      type(auto_diff_real_2var_order1), intent(out) :: FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX
+      real(dp), intent(in) :: RS,GAME,Zmean,Z2mean,Z52,Z53,Z321
+      real(dp), intent(out) :: FMIX,UMIX,PMIX,CVMIX,PDTMIX,PDRMIX
 
-      type(auto_diff_real_2var_order1) :: GAMImean, Dif0, DifR, DifFDH, D
-      type(auto_diff_real_2var_order1) :: P3, D0, GP, FMIX0, Q, R, GQ, G, GDG, UDG
-      
-      real(dp) :: TINY
-
-      TINY=1.d-9
+      real(dp) :: GAMImean, Dif0, DifR, DifFDH, D
+      real(dp) :: P3, D0, GP, FMIX0, Q, R, GQ, G, GDG, UDG
       
+      real(dp), parameter :: TINY=1.d-9
       GAMImean=GAME*Z53
       if (RS.lt.TINY) then ! OCP
-         Dif0=Z52-sqrt(Z2mean*Z2mean*Z2mean/Zmean)
+         Dif0=Z52-dsqrt(Z2mean*Z2mean*Z2mean/Zmean)
       else
-         Dif0=Z321-sqrt((Z2mean+Zmean)*(Z2mean+Zmean)*(Z2mean+Zmean)/Zmean)
+         Dif0=Z321-dsqrt((Z2mean+Zmean)*(Z2mean+Zmean)*(Z2mean+Zmean)/Zmean)
       endif
       DifR=Dif0/Z52
-      DifFDH=Dif0*GAME*sqrt(GAME/3d0) ! F_DH - F_LM(DH)
+      DifFDH=Dif0*GAME*sqrt(GAME/3.) ! F_DH - F_LM(DH)
       D=Z2mean/(Zmean*Zmean)
-      if (abs(D-1.d0).lt.TINY) then ! no correction
-         FMIX=0d0
-         UMIX=0d0
-         PMIX=0d0
-         CVMIX=0d0
-         PDTMIX=0d0
-         PDRMIX=0d0
+      if (dabs(D-1.d0).lt.TINY) then ! no correction
+         FMIX=0.
+         UMIX=0.
+         PMIX=0.
+         CVMIX=0.
+         PDTMIX=0.
+         PDRMIX=0.
          return
       endif
-      P3=pow(D,-0.2d0)
-      D0=(2.6d0*DifR+14d0*DifR*DifR*DifR)/(1.d0-P3)
-      GP=D0*pow(GAMImean,P3)
-      FMIX0=DifFDH/(1d0+GP)
-      Q=D*D*0.0117d0
-      R=1.5d0/P3-1d0
-      GQ=Q*GP
-      FMIX=FMIX0/pow(1d0+GQ,R)
-      G=1.5d0-P3*GP/(1d0+GP)-R*P3*GQ/(1d0+GQ)
+      P3=pow(D,-0.2d0) ! alpha
+      D0=(2.6d0*DifR+14.*DifR*DifR*DifR)/(1.d0-P3) ! a
+      GP=D0*pow(GAMImean,P3) ! common term in denominator
+      FMIX0=DifFDH/(1.+GP)
+      Q=D*D*0.0117d0 ! b/a
+      R=1.5d0/P3-1. ! beta
+      GQ=Q*GP ! 
+      FMIX=FMIX0/pow(1.+GQ,R)
+      G=1.5d0-P3*GP/(1.+GP)-R*P3*GQ/(1.+GQ) ! (3/2) - alpha*()
       UMIX=FMIX*G
       PMIX=UMIX/3.d0
       GDG=-P3*P3*(GP/((1.d0+GP)*(1.d0+GP))+R*GQ/((1.d0+GQ)*(1.d0+GQ))) ! d G /d ln Gamma
       UDG=UMIX*G+FMIX*GDG ! d u_mix /d ln Gamma
       CVMIX=UMIX-UDG
-      PDTMIX=PMIX-UDG/3d0
-      PDRMIX=PMIX+UDG/9d0
+      PDTMIX=PMIX-UDG/3.
+      PDRMIX=PMIX+UDG/9.
       return
       end subroutine CORMIX
 
 ! ===================  IDEAL ELECTRON GAS  =========================== *
-      subroutine ELECT11(TEMP,CHI, &
-        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE, &
-        DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT)
-!                                                       Version 17.11.11
-! ELECT9 v.04.03.09 + smooth match of two fits at chi >> 1 + add.outputs
+      subroutine ELECT9(TEMP,CHI, &
+        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN)
+!                                                       Version 21.01.10
+! ELECT9 v.04.03.09 + smooth match of two fits at chi=14
 ! Compared to ELECTRON v.06.07.00, this S/R is completely rewritten: 
 !        numerical differentiation is avoided now.
 ! Compared to ELECT7 v.06.06.07,
 !    - call BLIN7 is changed to call BLIN9,
-!    - Sommerfeld expansion is used at chi >~ 28 i.o. 1.e4
+!    - Sommerfeld expansion is used at chi > 14 i.o. 1.e4
 !    - Sommerfeld expansion is corrected: introduced DeltaEF, D1 and D2.
 ! Ideal electron-gas EOS.
 ! Input: TEMP - T [a.u.], CHI=\mu/T
@@ -1475,49 +1152,34 @@
 !         PEid - pressure (P_e) / n_e kT, SEid - entropy / N_e k,
 !         CVE - heat capacity / N_e k,
 !         CHITE=(d ln P_e/d ln T)_V, CHIRE=(d ln P_e/d ln n_e)_T
-!         DlnDH=(d ln n_e/d CHI)_T = (T/n_e) (d n_e/d\mu)_T
-!         DlnDT=(d ln n_e/d ln T)_CHI
-!         DlnDHH=(d^2 ln n_e/d CHI^2)_T
-!         DlnDTT=(d^2 ln n_e/d (ln T)^2)_CHI
-!         DlnDHT=d^2 ln n_e/d (ln T) d CHI
-      type(auto_diff_real_2var_order1), intent(in) :: TEMP,CHI
-      type(auto_diff_real_2var_order1), intent(out) :: DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT
+!         DDN=(d ln n_e/d CHI)_T = (T/n_e) (d n_e/d\mu)_T
+      real(dp), intent(in) :: TEMP,CHI
+      real(dp), intent(out) :: DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN
 
-      type(auto_diff_real_2var_order1) :: X2, FP, FM
-      type(auto_diff_real_2var_order1) :: DENSa,FEida,PEida,UEida,SEida,CVEa,CHITEa,CHIREa,DlnDHa,DlnDTa,DlnDHHa,DlnDTTa,DlnDHTa
-      type(auto_diff_real_2var_order1) :: DENSb,FEidb,PEidb,UEidb,SEidb,CVEb,CHITEb,CHIREb,DlnDHb,DlnDTb,DlnDHHb,DlnDTTb,DlnDHTb
+      real(dp) :: X2, FP, FM
+      real(dp) :: DENSa,FEida,PEida,UEida,SEida,CVEa,CHITEa,CHIREa,DDNa
+      real(dp) :: DENSb,FEidb,PEidb,UEidb,SEidb,CVEb,CHITEb,CHIREb,DDNb
       
-      type(auto_diff_real_2var_order1) :: CHI1
-      type(auto_diff_real_2var_order1) :: CHI2
-      type(auto_diff_real_2var_order1) :: XMAX
-      type(auto_diff_real_2var_order1) :: DCHI1
-      type(auto_diff_real_2var_order1) :: DCHI2
-      type(auto_diff_real_2var_order1) :: XSCAL2
-
-      CHI1=0.6d0
-      CHI2=28.d0
-      XMAX=20.d0
-      DCHI1=0.1d0
-      DCHI2=CHI2-CHI1-DCHI1
-      XSCAL2=XMAX/DCHI2
+      real(dp), parameter :: CHI1=0.6d0
+      real(dp), parameter :: CHI2=28.d0
+      real(dp), parameter :: XMAX=20.d0
+      real(dp), parameter :: DCHI1=0.1d0
+      real(dp), parameter :: DCHI2=CHI2-CHI1-DCHI1
+      real(dp), parameter :: XSCAL2=XMAX/DCHI2
       
       X2=(CHI-CHI2)*XSCAL2
       if (X2.lt.-XMAX) then
-         call ELECT11a(TEMP,CHI, &
-           DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,&
-           DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT)
+         call ELECT9a(TEMP,CHI, &
+           DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN)
       elseif (X2.gt.XMAX) then
-         call ELECT11b(TEMP,CHI, &
-           DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,&
-           DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT)
+         call ELECT9b(TEMP,CHI, &
+           DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN)
       else
-         call FERMI10(X2,XMAX,FP,FM)
-         call ELECT11a(TEMP,CHI, &
-           DENSa,FEida,PEida,UEida,SEida,CVEa,CHITEa,CHIREa, &
-           DlnDHa,DlnDTa,DlnDHHa,DlnDTTa,DlnDHTa)
-         call ELECT11b(TEMP,CHI, &
-           DENSb,FEidb,PEidb,UEidb,SEidb,CVEb,CHITEb,CHIREb,&
-           DlnDHb,DlnDTb,DlnDHHb,DlnDTTb,DlnDHTb)
+         call FERMI(X2,XMAX,FP,FM)
+         call ELECT9a(TEMP,CHI, &
+           DENSa,FEida,PEida,UEida,SEida,CVEa,CHITEa,CHIREa,DDNa)
+         call ELECT9b(TEMP,CHI, &
+           DENSb,FEidb,PEidb,UEidb,SEidb,CVEb,CHITEb,CHIREb,DDNb)
          DENS=DENSa*FP+DENSb*FM
          FEid=FEida*FP+FEidb*FM
          PEid=PEida*FP+PEidb*FM
@@ -1526,51 +1188,40 @@
          CVE=CVEa*FP+CVEb*FM
          CHITE=CHITEa*FP+CHITEb*FM
          CHIRE=CHIREa*FP+CHIREb*FM
-         DlnDH=DlnDHa*FP+DlnDHb*FM
-         DlnDT=DlnDTa*FP+DlnDTb*FM
-         DlnDHH=DlnDHHa*FP+DlnDHHb*FM
-         DlnDHT=DlnDHTa*FP+DlnDHTb*FM
-         DlnDTT=DlnDTTa*FP+DlnDTTb*FM
+         DDN=DDNa*FP+DDNb*FM
       endif
       return
-      end subroutine ELECT11
+      end subroutine ELECT9
 
-      subroutine ELECT11a(TEMP,CHI, &
-        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE, &
-        DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT)
-!                                                       Version 16.11.11
+      subroutine ELECT9a(TEMP,CHI, &
+        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN)
+!                                                       Version 19.01.10
 ! This is THE FIRST PART of ELECT9 v.04.03.09.
-      type(auto_diff_real_2var_order1), intent(in) :: TEMP,CHI
-      type(auto_diff_real_2var_order1), intent(out) :: DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT
-
-      type(auto_diff_real_2var_order1) :: TEMR
-      type(auto_diff_real_2var_order1) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
-      type(auto_diff_real_2var_order1) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
-      type(auto_diff_real_2var_order1) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
-      type(auto_diff_real_2var_order1) :: W0XXX,W0XTT,W0XXT
-      type(auto_diff_real_2var_order1) :: TPI, DENR, PR, U
-      type(auto_diff_real_2var_order1) :: dndT, dPdT, dUdT, dndH, dPdH, dUdH      
-      type(auto_diff_real_2var_order1) :: dndHH, dndHT, dndTT
-
-      type(auto_diff_real_2var_order1) :: BOHR
-      type(auto_diff_real_2var_order1) :: PI2
-      type(auto_diff_real_2var_order1) :: BOHR2
-      type(auto_diff_real_2var_order1) :: BOHR3
+      real(dp), intent(in) :: TEMP,CHI
+      real(dp), intent(out) :: DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN
+
+      real(dp) :: TEMR
+      real(dp) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
+      real(dp) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
+      real(dp) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
+      real(dp) :: W0XXX,W0XTT,W0XXT
+      real(dp) :: TPI, DENR, PR, U
+      real(dp) :: dndT, dPdT, dUdT, dndH, dPdH, dUdH
+      
+      real(dp), parameter :: BOHR=137.036d0
+      real(dp), parameter :: PI2=PI*PI
+      real(dp), parameter :: BOHR2=BOHR*BOHR
+      real(dp), parameter :: BOHR3=BOHR2*BOHR !cleaned 15/6
       
-      BOHR=137.036d0
-      PI2=PI*PI
-      BOHR2=BOHR*BOHR
-      BOHR3=BOHR2*BOHR !cleaned 15/6
-
       TEMR=TEMP/BOHR2 ! T in rel.units (=T/mc^2)
       call BLIN9(TEMR,CHI, &
         W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT, &
         W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT, &
         W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT, &
         W0XXX,W0XTT,W0XXT)
-      TPI=TEMR*sqrt(2.d0*TEMR)/PI2 ! common pre-factor
+      TPI=TEMR*dsqrt(2.d0*TEMR)/PI2 ! common pre-factor
       DENR=TPI*(W1*TEMR+W0)
-      PR=TEMR*TPI/3.d0*(W2*TEMR+2d0*W1)
+      PR=TEMR*TPI/3.*(W2*TEMR+2.*W1)
       U=TEMR*TPI*(W2*TEMR+W1)
 ! (these are density, pressure, and internal energy in the rel.units)
       PEid=PR/(DENR*TEMR)
@@ -1580,65 +1231,50 @@
       SEid=UEid-FEid
 ! derivatives over T at constant chi:
       dndT=TPI*(1.5d0*W0/TEMR+2.5d0*W1+W0DT+TEMR*W1DT) ! (d n_e/dT)_\chi
-      dPdT=TPI/3.d0*(5.d0*W1+2d0*TEMR*W1DT+3.5d0*TEMR*W2+TEMR*TEMR*W2DT)!dP/dT
+      dPdT=TPI/3.*(5.*W1+2.*TEMR*W1DT+3.5d0*TEMR*W2+TEMR*TEMR*W2DT)!dP/dT
       dUdT=TPI*(2.5d0*W1+TEMR*W1DT+3.5d0*TEMR*W2+TEMR*TEMR*W2DT)!dU/dT_\chi
 ! derivatives over chi at constant T:
       dndH=TPI*(W0DX+TEMR*W1DX) ! (d n_e/d\chi)_T
-      dndHH=TPI*(W0DXX+TEMR*W1DXX) ! (d^2 n_e/d\chi)_T
-      dndTT=TPI*(0.75d0*W0/pow2(TEMR)+3d0*W0DT/TEMR+W0DTT+3.75d0*W1/TEMR+5d0*W1DT+TEMR*W1DTT)
-      dndHT=TPI*(1.5d0*W0DX/TEMR+W0DXT+2.5d0*W1DX+TEMR*W1DXT)
-      DlnDH=dndH/DENR ! (d ln n_e/d\chi)_T
-      DlnDT=dndT*TEMR/DENR ! (d ln n_e/d ln T)_\chi
-      DlnDHH=dndHH/DENR-pow2(DlnDH) ! (d^2 ln n_e/d\chi^2)_T
-      DlnDTT=pow2(TEMR)/DENR*dndTT+DlnDT-pow2(DlnDT) ! d^2 ln n_e/d ln T^2
-      DlnDHT=TEMR/DENR*(dndHT-dndT*DlnDH) ! d^2 ln n_e/d\chi d ln T
-      dPdH=TPI/3d0*TEMR*(2d0*W1DX+TEMR*W2DX) ! (d P_e/d\chi)_T
+      DDN=dndH/DENR ! (d ln n_e/d\chi)_T
+      dPdH=TPI/3.*TEMR*(2.*W1DX+TEMR*W2DX) ! (d P_e/d\chi)_T
       dUdH=TPI*TEMR*(W1DX+TEMR*W2DX) ! (d U_e/d\chi)_T
       CVE=(dUdT-dUdH*dndT/dndH)/DENR
       CHITE=TEMR/PR*(dPdT-dPdH*dndT/dndH)
       CHIRE=DENR/PR*dPdH/dndH ! (dndH*TEMR*PEid) ! DENS/PRE*dPdH/dndH
       return
-      end subroutine ELECT11a
+      end subroutine ELECT9a
 
-      subroutine ELECT11b(TEMP,CHI, &
-        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE, &
-        DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT)
-!                                                       Version 17.11.11
-! Stems from ELECT9b v.19.01.10, Diff. - additional output.
+      subroutine ELECT9b(TEMP,CHI, &
+        DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN)
+!                                                       Version 19.01.10
+! This is THE SECOND PART of ELECT9 v.04.03.09, to be used in ELECT9:
 ! Sommerfeld expansion at very large CHI.
-      type(auto_diff_real_2var_order1), intent(in) :: TEMP,CHI
-      type(auto_diff_real_2var_order1), intent(out) :: DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DlnDH,DlnDT,DlnDHH,DlnDTT,DlnDHT
-
-      type(auto_diff_real_2var_order1) :: TEMR, EF, DeltaEF, G, PF, F, DF, P, DelP, S, U
-      type(auto_diff_real_2var_order1) :: DENR, DT, D1, D2
-      type(auto_diff_real_2var_order1) :: TPI, dndH, dndT, dndHH, dndHT, dndTT
-      type(auto_diff_real_2var_order1) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT,W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT,W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT,W0XXX,W0XTT,W0XXT      
-
-      type(auto_diff_real_2var_order1) :: BOHR
-      type(auto_diff_real_2var_order1) :: PI2
-      type(auto_diff_real_2var_order1) :: BOHR2
-      type(auto_diff_real_2var_order1) :: BOHR3
-
-      BOHR=137.036d0
-      PI2=PI*PI
-      BOHR2=BOHR*BOHR
-      BOHR3=BOHR2*BOHR !cleaned 15/6
+      real(dp), intent(in) :: TEMP,CHI
+      real(dp), intent(out) :: DENS,FEid,PEid,UEid,SEid,CVE,CHITE,CHIRE,DDN
 
+      real(dp) :: TEMR, EF, DeltaEF, G, PF, F, DF, P, DelP, S, U
+      real(dp) :: DENR, CMUDLN, DT, D1, D2
+      
+      real(dp), parameter :: BOHR=137.036d0
+      real(dp), parameter :: PI2=PI*PI
+      real(dp), parameter :: BOHR2=BOHR*BOHR
+      real(dp), parameter :: BOHR3=BOHR2*BOHR !cleaned 15/6
+      
       TEMR=TEMP/BOHR2 ! T in rel.units (=T/mc^2)
       EF=CHI*TEMR ! Fermi energy in mc^2 - zeroth aprox. = CMU1
       DeltaEF=PI2*TEMR*TEMR/6.d0*(1.d0+2.d0*EF*(2.d0+EF)) &
-             /(EF*(1.d0+EF)*(2.d0+EF)) ! corr. [page 125, equiv.Eq.(6) of PC'10]]
+             /(EF*(1.d0+EF)*(2.d0+EF)) ! corr. [page 125]
       EF=EF+DeltaEF ! corrected Fermi energy (14.02.09)
       G=1.d0+EF ! electron Lorentz-factor
       if (EF.gt.1.d-5) then ! relativistic expansion (Yak.&Shal.'89)
-        PF=sqrt(G*G-1.d0) ! Fermi momentum [rel.un.=mc]
-        F=(PF*(1d0+2.d0*PF*PF)*G-PF*PF*PF/0.375d0-log(PF+G))/8.d0/PI2!F/V
+        PF=dsqrt(G*G-1.d0) ! Fermi momentum [rel.un.=mc]
+        F=(PF*(1.+2.d0*PF*PF)*G-PF*PF*PF/0.375d0-log(PF+G))/8.d0/PI2!F/V
         DF=-TEMR*TEMR*PF*G/6.d0 ! thermal correction to F/V
         P=(PF*G*(PF*PF/1.5d0-1.d0)+log(PF+G))/8.d0/PI2 ! P(T=0)
         DelP=TEMR*TEMR*PF*(PF*PF+2.d0)/G/18.d0 ! thermal correction to P
         CVE=PI2*TEMR*G/(PF*PF)
       else ! nonrelativistic limit
-        PF=sqrt(2.d0*EF)
+        PF=dsqrt(2.d0*EF)
         F=pow5(PF)*0.1d0/PI2
         DF=-TEMR*TEMR*PF/6.d0
         P=F/1.5d0
@@ -1653,23 +1289,9 @@
       CHITE=2.d0*DelP/P
       DENR=PF*PF*PF/3.d0/PI2 ! n_e [rel.un.=\Compton^{-3}]
       DENS=DENR*BOHR3 ! conversion to a.u.(=\Bohr_radius^{-3})
-! derivatives over chi at constant T and T at constant chi:
-      TPI=TEMR*sqrt(2.d0*TEMR)/PI2 ! common pre-factor
-      call SOMMERF(TEMR,CHI, &
-        W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT, &
-        W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT, &
-        W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT,&
-        W0XXX,W0XTT,W0XXT)
-      dndH=TPI*(W0DX+TEMR*W1DX) ! (d n_e/d\chi)_T
-      dndT=TPI*(1.5d0*W0/TEMR+2.5d0*W1+W0DT+TEMR*W1DT) ! (d n_e/dT)_\chi
-      dndHH=TPI*(W0DXX+TEMR*W1DXX) ! (d^2 n_e/d\chi)_T
-      dndTT=TPI*(0.75d0*W0/pow2(TEMR)+3d0*W0DT/TEMR+W0DTT+3.75d0*W1/TEMR+5d0*W1DT+TEMR*W1DTT)
-      dndHT=TPI*(1.5d0*W0DX/TEMR+W0DXT+2.5d0*W1DX+TEMR*W1DXT)
-      DlnDH=dndH/DENR ! (d ln n_e/d\chi)_T
-      DlnDT=dndT*TEMR/DENR ! (d ln n_e/d ln T)_\chi
-      DlnDHH=dndHH/DENR-pow2(DlnDH) ! (d^2 ln n_e/d\chi^2)_T
-      DlnDTT=pow2(TEMR)/DENR*dndTT+DlnDT-pow2(DlnDT) ! d^2 ln n_e/d ln T^2
-      DlnDHT=TEMR/DENR*(dndHT-dndT*DlnDH) ! d^2 ln n_e/d\chi d ln T
+      CMUDLN=PF*PF/(3.d0*G) & ! d\mu/d ln n
+         + PI2*TEMR*TEMR*(1.d0+2.d0*(PF*G)*(PF*G))/(9.d0*(PF*G*G)*(PF*G*G)) !T-cor.
+      DDN=TEMR/CMUDLN ! d ln n / d\chi = (T/n)*(dn/d\mu)
       DT=DENR*TEMR
       PEid=P/DT
       UEid=U/DT
@@ -1682,127 +1304,18 @@
       SEid=SEid/(1.d0+D1)
       CHITE=CHITE/(1.d0+D2)
       return
-      end subroutine ELECT11b
-
-      subroutine SOMMERF(TEMR,CHI, &
-        W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT, &
-        W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT, &
-        W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT, &
-        W0XXX,W0XTT,W0XXT)
-!                                                       Version 17.11.11
-! Sommerfeld expansion for the Fermi-Dirac integrals
-! Input: TEMR=T/mc^2; CHI=(\mu-mc^2)/T
-! Output: Wk - Fermi-Dirac integral of the order k+1/2
-!         WkDX=dWk/dCHI, WkDT = dWk/dT, WkDXX=d^2 Wk / d CHI^2,
-!         WkDTT=d^2 Wk / d T^2, WkDXT=d^2 Wk /dCHIdT,
-!         W0XXX=d^3 W0 / d CHI^3, W0XTT=d^3 W0 /(d CHI d^2 T),
-!         W0XXT=d^3 W0 /dCHI^2 dT
-! [Draft source: yellow book pages 124-127]
-
-      type(auto_diff_real_2var_order1), intent(in) :: TEMR,CHI
-      type(auto_diff_real_2var_order1), intent(out) :: W0,W0DX,W0DT,W0DXX,W0DTT,W0DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W1,W1DX,W1DT,W1DXX,W1DTT,W1DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W2,W2DX,W2DT,W2DXX,W2DTT,W2DXT
-      type(auto_diff_real_2var_order1), intent(out) :: W0XXX,W0XTT,W0XXT
-
-      type(auto_diff_real_2var_order1) :: CMU, CMU1, PIT26, CN0, CN1, CN2
-      type(auto_diff_real_2var_order1) :: CJ00,CJ10,CJ20,CJ01,CJ11,CJ21,CJ02,CJ12,CJ22,CJ03,CJ13,CJ23,CJ04,CJ14,CJ24,CJ05
-
-      if (CHI.lt..5d0) stop 'SOMMERF: non-degenerate (small CHI)'
-      if (TEMR.le.0.d0) stop 'SOMMERF: T < 0'
-      CMU1=CHI*TEMR ! chemical potential in rel.units
-      CMU=1.d0+CMU1
-      call SUBFERMJ(CMU1, &
-        CJ00,CJ10,CJ20, &
-        CJ01,CJ11,CJ21, &
-        CJ02,CJ12,CJ22, &
-        CJ03,CJ13,CJ23, &
-        CJ04,CJ14,CJ24,CJ05)
-      PIT26=pow2(PI*TEMR)/6.d0
-!!!     PITAU4=pow2(PIT26)*0.7d0
-      CN0=sqrt(.5d0/TEMR)/TEMR
-      CN1=CN0/TEMR
-      CN2=CN1/TEMR
-      W0=CN0*(CJ00+PIT26*CJ02) ! +CN0*PITAU4*CJ04
-      W1=CN1*(CJ10+PIT26*CJ12) ! +CN1*PITAU4*CJ14
-      W2=CN2*(CJ20+PIT26*CJ22) ! +CN2*PITAU4*CJ24
-      W0DX=CN0*TEMR*(CJ01+PIT26*CJ03) ! +CN0*PITAU4*CJ05
-      W1DX=CN0*(CJ11+PIT26*CJ13)
-      W2DX=CN1*(CJ21+PIT26*CJ23)
-      W0DT=CN1*(CMU1*CJ01-1.5d0*CJ00+PIT26*(CMU1*CJ03+.5d0*CJ02))
-!!!     +  CN1*PITAU4*(CMU1*CJ05+2.5d0*CJ04)
-      W1DT=CN2*(CMU1*CJ11-2.5d0*CJ10+PIT26*(CMU1*CJ13-.5d0*CJ12))
-      W2DT=CN2/TEMR*(CMU1*CJ21-3.5d0*CJ20+PIT26*(CMU1*CJ23-1.5d0*CJ22))
-      W0DXX=CN0*pow2(TEMR)*(CJ02+PIT26*CJ04)
-      W1DXX=CN0*TEMR*(CJ12+PIT26*CJ14)
-      W2DXX=CN0*(CJ22+PIT26*CJ24)
-      W0DXT=CN0*(CMU1*CJ02-.5d0*CJ01+PIT26*(CMU1*CJ04+1.5d0*CJ03))
-      W1DXT=CN1*(CMU1*CJ12-1.5d0*CJ11+PIT26*(CMU1*CJ14+.5d0*CJ13))
-      W2DXT=CN2*(CMU1*CJ22-2.5d0*CJ21+PIT26*(CMU1*CJ24-.5d0*CJ23))
-      W0DTT=CN2*(3.75d0*CJ00-3.d0*CMU1*CJ01+pow2(CMU1)*CJ02+PIT26*(-.25d0*CJ02+CMU1*CJ03+pow2(CMU1)*CJ04))
-      W1DTT=CN2/TEMR*(8.75d0*CJ10-5.d0*CMU1*CJ11+pow2(CMU1)*CJ12+PIT26*(.75d0*CJ12-CMU1*CJ13+pow2(CMU1)*CJ14))
-      W2DTT=CN2/pow2(TEMR)*(15.75d0*CJ20-7.d0*CMU1*CJ21+pow2(CMU1)*CJ22+PIT26*(3.75d0*CJ22-3.d0*CMU1*CJ23+pow2(CMU1)*CJ24))
-      W0XXX=CN0*pow3(TEMR)*(CJ03+PIT26*CJ05)
-      W0XXT=CN0*TEMR*(CMU1*CJ03+.5d0*CJ02+PIT26*(CMU1*CJ05+2.5d0*CJ04))
-      W0XTT=CN1*(.75d0*CJ01-CMU1*CJ02+pow2(CMU1)*CJ03+PIT26*(.75d0*CJ03+3.d0*CMU1*CJ04+pow2(CMU1)*CJ05))
-      return
-      end subroutine SOMMERF
-
-      subroutine SUBFERMJ(CMU1, &
-        CJ00,CJ10,CJ20, &
-        CJ01,CJ11,CJ21, &
-        CJ02,CJ12,CJ22, &
-        CJ03,CJ13,CJ23, &
-        CJ04,CJ14,CJ24,CJ05)
-!                                                       Version 17.11.11
-! Supplement to SOMMERF
-
-      type(auto_diff_real_2var_order1), intent(in) :: CMU1
-      type(auto_diff_real_2var_order1), intent(out) :: CJ00,CJ10,CJ20,CJ01,CJ11,CJ21,CJ02,CJ12,CJ22,CJ03,CJ13,CJ23,CJ04,CJ14,CJ24,CJ05
-
-      type(auto_diff_real_2var_order1) :: X0, X3, X5, CL, CMU
-
-      if (CMU1.le.0.d0) stop 'SUBFERMJ: small CHI'
-      CMU=1.d0+CMU1
-      X0=sqrt(CMU1*(2.d0+CMU1))
-      X3=pow3(X0)
-      X5=pow5(X0)
-      if (X0.lt.1d-4) then
-         CJ00=X3/3.d0
-         CJ10=0.1d0*X5
-         CJ20=pow7(X0)/28.d0
-      else
-         CL=log(X0+CMU)
-         CJ00=0.5d0*(X0*CMU-CL) ! J_{1/2}^0
-         CJ10=X3/3d0-CJ00 ! J_{3/2}^0
-         CJ20=(0.75d0*CMU-2d0)/3d0*X3+1.25d0*CJ00 ! J_{5/2}^0
-      endif
-      CJ01=X0 ! J_{1/2}^1
-      CJ11=CJ01*CMU1 ! J_{3/2}^1
-      CJ21=CJ11*CMU1 ! J_{5/2}^1
-      CJ02=CMU/X0 ! J_{1/2}^2
-      CJ12=CMU1/X0*(3.d0+2.d0*CMU1) ! J_{3/2}^2
-      CJ22=pow2(CMU1)/X0*(5.d0+3.d0*CMU1) ! J_{5/2}^2
-      CJ03=-1.d0/X3 ! J_{1/2}^3
-      CJ13=CMU1/X3*(2.d0*pow2(CMU1)+6.d0*CMU1+3.d0)
-      CJ23=pow2(CMU1)/X3*(6.d0*pow2(CMU1)+2.d1*CMU1+1.5d1)
-      CJ04=3.d0*CMU/X5
-      CJ14=-3.d0*CMU1/X5
-      CJ24=pow2(CMU1)/X5*(6.d0*pow3(CMU1)+3.d1*pow2(CMU1)+45.d0*CMU1+15.d0)
-      CJ05=(-12.d0*pow2(CMU1)-24.d0*CMU1-15.d0)/(X5*pow2(X0))
-      return
-      end subroutine SUBFERMJ
+      end subroutine ELECT9b
 
-      subroutine FERMI10(X,XMAX,FP,FM)
+      subroutine FERMI(X,XMAX,FP,FM)
 !                                                       Version 20.01.10
 ! Fermi distribution function and its 3 derivatives
 ! Input: X - argument f(x)
 !        XMAX - max|X| where it is assumed that 0 < f(x) < 1.
 ! Output: FP = f(x)
 !         FM = 1-f(x)
-      type(auto_diff_real_2var_order1), intent(in) :: X
-      type(auto_diff_real_2var_order1) :: XMAX  ! not sure if this side-effect is desired
-      type(auto_diff_real_2var_order1), intent(out) :: FP, FM
+      real(dp), intent(in) :: X
+      real(dp) :: XMAX  ! not sure if this side-effect is desired
+      real(dp), intent(out) :: FP, FM
       
       if (XMAX.lt.3.d0) XMAX = 3d0 !stop 'FERMI: XMAX'
       if (X.gt.XMAX) then
@@ -1816,7 +1329,7 @@
          FM=1.d0-FP
       endif
       return
-      end subroutine FERMI10
+      end subroutine FERMI
 
 ! ==============  ELECTRON EXCHANGE AND CORRELATION   ================ *
       subroutine EXCOR7(RS,GAME,FXC,UXC,PXC,CVXC,SXC,PDTXC,PDRXC)
